
<template>
    <AppLayout title="Dashboard">
        <template #header>
            <h2 class="font-semibold text-xl text-gray-800 leading-tight">

                <chat-room-selection
                    v-if="selectedChatRoom"
                    :rooms="chatRooms"
                    :currentRoom="selectedChatRoom"
                    @room-changed="setSelectedChatRoom($event)"
                 />
            </h2>
        </template>

        <div class="py-12">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
                <div class="bg-white overflow-hidden shadow-xl sm:rounded-lg">
                    <message-container :messages="messages" />
                    <message-input  :room="selectedChatRoom" v-on:message-sent="getMessages()" />
                </div>
            </div>
        </div>
    </AppLayout>
</template>

<script>
import AppLayout from '@/Layouts/AppLayout.vue';
import MessageContainer from '@/Pages/Chat/MessageContainer.vue';
import MessageInput from '@/Pages/Chat/MessageInput.vue';
import ChatRoomSelection from '@/Pages/Chat/ChatRoomSelection.vue';
export default {

    components: {
        AppLayout,
        MessageContainer,
        MessageInput,
        ChatRoomSelection,
    },

    data() {
        return {
            chatRooms: [],
            selectedChatRoom: null,
            messages: [],
        }
    },
    watch: {
        selectedChatRoom(oldRoom, newRoom) {
            if (oldRoom) {
                this.disconnectFromRoom(oldRoom);
            }
            this.connect();
        },
    },
    methods: {
        connect() {
            if(this.selectedChatRoom) {
                let vm = this;
                this.getMessages();
                Echo.private('chat-room.' + this.selectedChatRoom.id)
                    .listen('.ChatRoomMessageSent', (e) => {
                        vm.getMessages();
                    });
            }
        },
        disconnectFromRoom( room ) {

            Echo.leave('chat-room.' + room.id);
        },
        getRooms() {
            axios.get('/chat/rooms').then(response => {
                this.chatRooms = response.data;
                this.setSelectedChatRoom(response.data[0]); // set the first room as selected
            })
            .catch(error => {
                console.log(error);
            });
        },
        setSelectedChatRoom(room){
            this.selectedChatRoom = room;
            this.getMessages();
        },
        getMessages() {
            axios.get('/chat/room/' + this.selectedChatRoom.id + '/messages').then(response => {
                this.messages = response.data;
            })
            .catch(error => {
                console.log(error);
            });
        },
    },
    created() {
        this.getRooms();
    }
}
</script>
